"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.switchTab = exports.applescriptPaste = exports.applescriptCopy = exports.PASTE = undefined;

var _runScript = require("./runScript");

var _runScript2 = _interopRequireDefault(_runScript);

var _clipboard = require("./clipboard");

var _platform = require("./platform");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PASTE = exports.PASTE = "tell application \"System Events\" to keystroke \"v\" using command down";

var applescriptCopy = exports.applescriptCopy = async function applescriptCopy(text) {
  await (0, _clipboard.setToClipboard)(text);
};

var applescriptPaste = exports.applescriptPaste = async function applescriptPaste() {
  var result = await _runScript2.default.applescript(PASTE);
  return result;
};

var switchTab = exports.switchTab = async function switchTab(content) {
  var oldClipboard = (0, _clipboard.getFromClipboard)();
  await applescriptCopy(content);
  if ((0, _platform.isMac)()) {
    var switchTo = 'tell application "System Events" \n' + "   key down command \n" + "   keystroke tab \n" + "   key up command \n" + "end tell\n";
    await _runScript2.default.applescript(switchTo);
    await applescriptPaste();
  } else {
    await undefined.robot.tap("tab", "COMMAND");
    await undefined.robot.tap("V", "CONTROL");
  }
  setTimeout(function () {
    applescriptCopy(oldClipboard);
  }, 500);
};
//# sourceMappingURL=applescript.js.map