'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isLinux = exports.isMac = exports.isWindows = exports.platformName = undefined;

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _osName = require('os-name');

var _osName2 = _interopRequireDefault(_osName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var platformName = (0, _osName2.default)(_os2.default.platform(), _os2.default.release());

var isWindows = function isWindows() {
  if (typeof process === 'undefined' || !process) {
    return false;
  }
  return process.platform === 'win32' || process.env.OSTYPE === 'cygwin' || process.env.OSTYPE === 'msys';
};

var isMac = function isMac() {
  if (typeof process === 'undefined' || !process) {
    return false;
  }
  return process.platform === 'darwin';
};

var isLinux = function isLinux() {
  if (typeof process === 'undefined' || !process) {
    return false;
  }
  return process.platform === 'linux';
};

exports.platformName = platformName;
exports.isWindows = isWindows;
exports.isMac = isMac;
exports.isLinux = isLinux;
//# sourceMappingURL=platform.js.map